#include <bits/stdc++.h>

using namespace std;
struct pacijent{
    string grupa;
    int krv;
};
struct resenje{
    int O = 0,A = 0,B = 0,AB = 0;
};
int main()
{
    int n,O,A,B,AB;
    bool moguce = true;
    cin>>n>>O>>A>>B>>AB;
    pacijent p[n];
    resenje r[n];
    for(int i = 0; i<n; i++){
        cin>>p[i].grupa>>p[i].krv;
    }
    for(int i = 0; i<n; i++){
        if(p[i].grupa=="O"){
            r[i].O = min(O,p[i].krv);
            O-= min(O,p[i].krv);
            p[i].krv-=r[i].O;
            if(p[i].krv>0){
                moguce = false;
                break;
            }
        }
        else if(p[i].grupa=="A"){
            r[i].A = min(A,p[i].krv);
            A-= min(A,p[i].krv);
            p[i].krv-=r[i].A;
            r[i].O = min(O,p[i].krv);
            O-= min(O,p[i].krv);
            p[i].krv-=r[i].O;
            if(p[i].krv>0){
                moguce = false;
                break;
            }
        }
        else if(p[i].grupa=="B"){
            r[i].B = min(B,p[i].krv);
            B-= min(B,p[i].krv);
            p[i].krv-=r[i].B;
            r[i].O = min(O,p[i].krv);
            O-= min(O,p[i].krv);
            p[i].krv-=r[i].O;
            if(p[i].krv>0){
                moguce = false;
                break;
            }
        }
    }
    for(int i = 0; i<n; i++){
        if(p[i].grupa=="AB"){
            r[i].AB = min(AB,p[i].krv);
            AB-= min(AB,p[i].krv);
            p[i].krv-=r[i].AB;
            r[i].A = min(A,p[i].krv);
            A-= min(AB,p[i].krv);
            p[i].krv-=r[i].A;
            r[i].B = min(B,p[i].krv);
            B-= min(B,p[i].krv);
            p[i].krv-=r[i].B;
            r[i].O = min(O,p[i].krv);
            O-= min(O,p[i].krv);
            p[i].krv-=r[i].O;
            if(p[i].krv>0){
                moguce = false;
                break;
            }
        }
    }
    if(moguce){
        cout<<"moguce"<<endl;
        for(int i = 0; i<n;i++){
            cout<<r[i].O<<" "<<r[i].A<<" "<<r[i].B<<" "<<r[i].AB<<endl;
        }
    }
    else{
        cout<<"nemoguce"<<endl;
    }
    return 0;
}